#!/usr/local/bin/perl
##-----------------------------------------------------------------##
##                                                                 ##
##                                                                 ##
##  Copyright Mr Lyle R Hopkins 1999. All rights reserved. No part##
## of this or any of the attached documents shall be               ##
## reproduced/stored in any way whatsoever without written         ##
## permission from the Copyright holder.                           ##
##   The Copyright holder holds no responsibility for errors or    ##
## omissions. No liability is assumed in any way for damages       ##
## resulting from the use of this document/program.                ##
##                                                                 ##
## Have a nice day.                                                ##
##                                                                 ##
##                                                                 ##
##-----------------------------------------------------------------##

## By Lyle Hopkins ##

print "Content-type: text/html\n\n";

##################################################
######################## Define variables
##################################################

$programurl = "http://ukzone.hypermart.net/scripts/faq";
$threadsymbol = "-"; ## Symbol to put infront of a reply message
$maxlength = 30; ## Max number of posts to have, if above is on

## Optional's
$rplymessagebg = "#FFCC99";
$messagefont = "Verdana";
$messagecolour = "#3333FF";
$messagesize = "+0";
$messagebg = "#FFCC33";
$threadfont = "Verdana";
$threadcolour = "#3333FF";
$threadsize = "+0";


##################################################
######################## Other variables
##################################################

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time); ## Get date

if ($mon < 10) {
      $mon = "0$mon";
   }
if ($mday < 10) {
      $mday = "0$mday";
   }
$month = ($mon + 1);

$year = $year + 1900;

$date = "$month/$mday/$year"; ## Get date

chop($date) if ($date =~ /\n$/); ## clean up date

@months = ("january","february","march","april","may","june","july","august","september","october","november","december");

## use $months[$mon] to get month name

@values = split(/\&/,$ENV{'QUERY_STRING'});
foreach $i (@values) {
($varname, $mydata) = split(/=/,$i); ## 50
$WHATWANT{$varname} = $mydata;
}


$subjectb = "";
$nameb = "";
$emailb = "";
$threadnumb = "";
$dateb = "";
$messageb = "";
$replymessagenumb = 2000000;
$runthreading = 0;


##################################################
######################## See what to do
##################################################

if ($WHATWANT{'want'} eq "add") {
      &addmessage();
   }
if ($WHATWANT{'want'} eq "showlist") {
      &showlist();
   }
if ($WHATWANT{'want'} eq "showmessage") {
      &showmessage();
   }
if ($WHATWANT{'want'} eq "admin") {
      &admin();
   }
if ($WHATWANT{'want'} eq "remove") {
      &remove();
   }
if ($WHATWANT{'want'} eq "enteradmin") {
        ## Get user input
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
   }
        ## Get file Username and password
   open(INF,"adminpass.txt"); ## Open read file
   $userpass = <INF>; ## Put into an array
   close(INF); ## Close file
   chomp($userpass);
   ($username, $password) = split(/:/, $userpass);
   $enterpasscrypt = crypt($FORM{'password'}, substr($password, 0, 2));
        ## If they match
   if ($FORM{'username'} eq $username && $enterpasscrypt eq $password){
      &enteradmin();
   } ## End if
   }
exit;


##################################################
######################## Actions to take
##################################################

##################################################
######################## Enter Admin
##################################################

sub admin {

print <<EndHTML;

<p align="center"><font size="6">Enter password to enter Admin
area</font></p>

<p align="center">&nbsp;</p>

<form action="$programurl/bbs.cgi?want=enteradmin" method="POST">
    <p align="center">Username <input type="text" size="20"
    name="username"></p>
    <p align="center">Password <input type="text" size="20"
    name="password"></p>
    <p align="center"><input type="submit" value="Enter"></p>
</form>

EndHTML
;

exit;
} ## End sub


##################################################
######################## The page
##################################################

sub enteradmin {


## Open message list
$linenum = 1;
open(INF,"messages.txt"); ## Open read file
@userdata = <INF>; ## Put into an array
close(INF); ## Close file
foreach $line (@userdata) {
chomp($line);
## ($pictureb, $alttextb, $textb, $linkerb, $positionb) = split(//, $line);
$LINKSLIST{$linenum} = $line;
$linenum++;
}

print <<EndHTML;
<CENTER><B><FONT FACE="Arial,Helvetica"><FONT COLOR="#FF0000">Posts on board</FONT></FONT></B></CENTER>
<CENTER>&nbsp;</CENTER>
EndHTML
;


for ( $key = 1 ; $key < $linenum ; $key++ ) { ## Userfile loop

($name, $slogan, $url, $email) = split(//, $LINKSLIST{$key});

print <<EndHTML;
<CENTER><B><FONT FACE="Arial,Helvetica"><FONT COLOR="#FF0000"><FONT SIZE=+1>$key
</FONT>$name $slogan $url $email</FONT></FONT></B></CENTER>
EndHTML
;

} ## End loop


print <<EndHTML;

<CENTER>&nbsp;</CENTER>
<CENTER>&nbsp;</CENTER>
<FORM method="POST" action="$programurl/bbs.cgi?want=remove">
<CENTER>Remove link number:-</CENTER>
<CENTER><INPUT type="text" size="4" name="looselink"></CENTER>
<CENTER><INPUT type="submit" value="Remove"></CENTER>
</FORM>

EndHTML
;

} ## End sub


##################################################
######################## Add message to list
##################################################

sub addmessage {

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}

## Run filter
## if ($FORM{'message'} =~ /($filters)/gis) {
## &smegup();
## }


$linenum = 1;
open(INF,"messages.txt"); ## Open read file
@userdata = <INF>; ## Put into an array
close(INF); ## Close file
foreach $line (@userdata) {
chomp($line);
## ($subjectb, $nameb, $emailb, $threadnumb, $dateb, $messageb) = split(//, $line);
$BBSMESSAGES{$linenum} = $line;
$linenum++;
}

## Add reply message in place

if ($FORM{'reply'} eq "yes") {
$replymessagenumb = $FORM{'messagenum'};
$threader = $FORM{'threader'} + 1;
$FORM{'message'} =~ s/\n/~\*/g;
$replymessage = "$FORM{'subject'}$FORM{'name'}$FORM{'email'}$threader$date$FORM{'message'}";
} ## End if
else {
$messagenumb = $linenum;
$threader = 0;
$FORM{'message'} =~ s/\n/~\*/g;
$BBSMESSAGES{$messagenumb} = "$FORM{'subject'}$FORM{'name'}$FORM{'email'}$threader$date$FORM{'message'}";
} ## End else
$linenumin = $linenum - 1;

open(OUTF,">messages.txt"); ##  File for appending

if ($linenum == 1) {
print OUTF
"$BBSMESSAGES{$linenum}\n"; ## Write user fields
}

for ( $key = 1 ; $key < $linenum ; $key++ ) { ## Userfile loop

## Del spillover messages
if ($linenum > $maxlength && $key == 1) {
## Skip message
} ## End if
else {
print OUTF
"$BBSMESSAGES{$key}\n"; ## Write user fields
} ## End else

if ($key == $linenumin && $BBSMESSAGES{$linenum} ne "") {
print OUTF
"$BBSMESSAGES{$linenum}\n"; ## Write user fields
}

if ($key == $replymessagenumb) {
print OUTF
"$replymessage\n"; ## Write user fields
}

} ## End loop

close(OUTF); ## Close file

print "Message Added";

} ## End sub


##################################################
######################## Display BBS
##################################################

sub showlist {

$linenum = 1;
open(INF,"messages.txt"); ## Open read file
@userdata = <INF>; ## Put into an array
close(INF); ## Close file
foreach $line (@userdata) {
chomp($line);
## ($subjectb, $nameb, $emailb, $threadnumb, $dateb, $messageb) = split(//, $line);
$BBSMESSAGES{$linenum} = $line;
$linenum++;
}


open(INF,"board.html"); ## Open read file
@userdata = <INF>; ## Put into an array
close(INF); ## Close file
$thepage = join(@userdata);
($pagetop, $pagebottom) = split(/messageboard/, $thepage);
print "$pagetop";


for ( $key = 1 ; $key < $linenum ; $key++ ) { ## Userfile loop
($subjectb, $nameb, $emailb, $threadnumb, $dateb, $messageb) = split(//, $BBSMESSAGES{$key});
&tablemaker();
} ## End loop


&addmessagepage();

print "$pagebottom";

print <<EndHTML;

<center><table BORDER WIDTH="150" >
<tr>
<td>
<center><font face="Comic Sans MS"><font color="#000099"><font size=-2>This
script &amp; more available from</font></font></font>
<br><font face="Comic Sans MS"><font color="#FF0000"><font size=-2>-Lyles
Script archive-</font></font></font>
<br><font face="Comic Sans MS"><font color="#000099"><font size=-2><a href="http://ukzone.hypermart.net/scripts">Click
here</a></font></font></font></center>
</td>
</tr>
</table></center>

EndHTML
;


} ## End sub


##################################################
######################## Reply message form
##################################################

sub replyform {

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}

## Include hidden fields: reply , etc
print <<EndHTML;

<p align="center"><font size="4" face="Comic Sans MS">Add reply message</font></p>

<p align="center">&nbsp;</p>

<form action="$programurl/bbs.cgi?want=add" method="POST">
    <input type="hidden" name="reply" value="yes">
    <input type="hidden" name="messagenum" value="$WHATWANT{'messagenum'}"><input
    type="hidden" name="threader" value="$threadnumb"><p
    align="center">Subject <input maxlength="40" type="text" size="40"
    name="subject"></p>
    <p align="center">Name <input maxlength="40" type="text" size="40"
    name="name"></p>
    <p align="center">E-mail <input type="text" size="40"
    name="email"></p>
    <p align="center">Message</p>
    <p align="center"><textarea name="message" rows="8"
    cols="70"></textarea></p>
    <p align="center"><input type="submit" value="Add Message"> <input
    type="reset" value="Reset"></p>
</form>


EndHTML
;


} ## End sub


##################################################
######################## Smegup
##################################################

sub smegup {

print "Mistake";

} ## End sub


##################################################
######################## Tablemaker
##################################################

sub tablemaker {


$runthreading = 0;

if ($threadnumb ne 0) {

print "<CENTER><TABLE BORDER=0 CELLSPACING=1 CELLPADDING=1 WIDTH=\"100%\" BGCOLOR=\"$rplymessagebg\">";
print <<EndHTML;

<TR>
<TD VALIGN=TOP>
<FONT FACE="$threadfont"><FONT COLOR="$threadcolour"><FONT SIZE=$threadsize>

EndHTML
;
$runthreading = 1;

}
else {
print "<CENTER><TABLE BORDER=0 CELLSPACING=1 CELLPADDING=1 WIDTH=\"100%\" BGCOLOR=\"$messagebg\">";
}


while ($threadnumb > 0) {

print "$threadsymbol";

$threadnumb--;

} ## End while


if ($runthreading) {

print <<EndHTML;

</FONT></FONT></FONT>
</TD>

EndHTML
;

}


print <<EndHTML;

<TD VALIGN=TOP>
<FONT FACE="$messagefont"><FONT COLOR="$messagecolour"><FONT SIZE=$messagesize><a href="$programurl/bbs.cgi?want=showmessage&messagenum=$key">$subjectb</a></FONT></FONT></FONT>
</TD>

<TD>
<FONT FACE="$messagefont"><FONT COLOR="$messagecolour"><FONT SIZE=$messagesize>$nameb</FONT></FONT></FONT>
</TD>

<TD>
<FONT FACE="$messagefont"><FONT COLOR="$messagecolour"><FONT SIZE=$messagesize>$dateb</FONT></FONT></FONT>
</TD>
</TR>

</TABLE></CENTER>


EndHTML
;


} ## End sub


##################################################
######################## Display message
##################################################

sub showmessage {

$linenum = 1;
open(INF,"messages.txt"); ## Open read file
@userdata = <INF>; ## Put into an array
close(INF); ## Close file
foreach $line (@userdata) {
chomp($line);
## ($subjectb, $nameb, $emailb, $threadnumb, $dateb, $messageb) = split(//, $line);
$BBSMESSAGES{$linenum} = $line;
$linenum++;
}

($subjectb, $nameb, $emailb, $threadnumb, $dateb, $messageb) = split(//, $BBSMESSAGES{$WHATWANT{'messagenum'}});

$messageb =~ s/~\*/<\/center>\n<center>/g;

print <<EndHTML;

<center><table BORDER WIDTH="100%" >
<tr>
<td>Subject</td>

<td>$subjectb</td>
</tr>

<tr>
<td>Name</td>

<td>$nameb</td>
</tr>

<tr>
<td>E-mail</td>

<td>$emailb</td>
</tr>

<tr>
<td>Date posted</td>

<td>$dateb</td>
</tr>
</table>

<table BORDER COLS=1 WIDTH="100%" >
<tr>
<td>
<center>Message</center>
</td>
</tr>

<tr>
<td>
<center>$messageb</center>
</td>
</tr>
</table></center>

EndHTML
;

&replyform();

} ## End sub


##################################################
######################## Add message page
##################################################

sub addmessagepage {

print <<EndHTML;

<p align="center"><font size="4" face="Comic Sans MS">Add message</font></p>

<p align="center">&nbsp;</p>

<form action="$programurl/bbs.cgi?want=add" method="POST">
    <p align="center">Subject <input maxlength="40" type="text" size="40"
    name="subject"></p>
    <p align="center">Name <input maxlength="40" type="text" size="40"
    name="name"></p>
    <p align="center">E-mail <input type="text" size="40"
    name="email"></p>
    <p align="center">Message</p>
    <p align="center"><textarea name="message" rows="8"
    cols="70"></textarea></p>
    <p align="center"><input type="submit" value="Add Message"> <input
    type="reset" value="Reset"></p>
</form>


EndHTML
;


} ## End sub


##################################################
######################## Remove link
##################################################

sub remove {

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}

## Load all links
$linenum = 1;
open(INF,"messages.txt"); ## Open read file
@userdata = <INF>; ## Put into an array
close(INF); ## Close file
foreach $line (@userdata) {
chomp($line);
## ($pictureb, $alttextb, $textb, $linkerb, $positionb) = split(//, $line);
$LINKSLIST{$linenum} = $line;
$linenum++;
}

open(OUTF,">messages.txt"); ##  File for appending

for ( $key = 1 ; $key < $linenum ; $key++ ) { ## Userfile loop

if ($key ne $FORM{'looselink'}) {
print OUTF
"$LINKSLIST{$key}\n"; ## Write user fields
} ## End if

} ## End loop

close(OUTF); ## Close file

} ## End sub
